/*
 * Synergy KB/PD driver (based on rsdrv sample)
 *
 * (C)Copyright 2008, Yashiro Takeshi
 */

#include <basic.h>
#include <btron/device.h>
#include <bstring.h>
#include <tstring.h>
#include <tctype.h>
#include <tcode.h>
#include "syndrv.h"

extern ERR synergyAcceptDeviceRequest(SynergyDriverInfo *inf, UW reqptn);


/*
 * Synergy ɥ饤Хͥ
 */
static PRI taskPri = DefaultPriority;


/*
 * ǥХϿ
 *	Ͽ	reg = True
 *		reg = False
 */
static WERR registDevice(SynergyDriverInfo *inf, Bool reg)
{
  static const DevDef def = {
    {0}, /* attr */
    0, /* subunits */
    {L""}, /* name */
    0 /* portid */
  };
  DevDef devDef;
  ERR err;

  /* Ͽ */
  devDef = def;
  devDef.attr.devinfo = 0;
  devDef.attr.devkind = DK_UNDEF; /* ǥʳ */
  devDef.attr.openreq = 0;
  devDef.attr.lockreq = 0; /* ɥ쥹֤Υå⼫ʬǤ */
  devDef.attr.diskinfo = 0;
  devDef.attr.chardev = 0;
  devDef.attr.nowait = 0;
  devDef.attr.eject = 0;
  devDef.portid = (reg ? inf->acceptPort : -1);

  /* ǥХϿ */
  err = b_DefDevice(&devDef, NULL);
  if (err < ER_OK) {
    goto err_ret;
  }
  inf->devID = (ID)err;

  return ER_OK;

err_ret:
  DEBUG_PRINT(("registDevice err = %d\n", err));
  return err;
}


/*
 * ü׵դ
 */
static void synergySpecificRequestTask(SynergyDriverInfo *inf)
{
  ERR	err;

  /* ǥХ׵դ */
  err = synergyAcceptDeviceRequest(inf, D_ABORT_PTN);

  /*
   * ǥХɥ饤С̾ｪλʤΤǡ
   * 뤳ȤϤʤϤ
   */

  DEBUG_PRINT(("synergySpecificRequestTask err = %d\n", err));
  exd_tsk();
}


/*
 * ̾׵դ
 */
static void synergyMainTask(SynergyDriverInfo *inf)
{
  static UB nm[] = "syndrv";
  static TC kbpdnm[] = {L""};
  T_CPOR cpor;
  T_CTSK ctsk;
  ID tskid;
  ERR err;
  W dd = -1;
  W asize, error;
  ID kpinput;

  /* å */
  err = CreateLockWN(&inf->lock, nm); // "with name"
  if (err < ER_OK ) {
    goto err_ret0;
  }

  /* KB/PDɥ饤  DN_KPINPUT  */
  err = b_opn_dev(kbpdnm, D_READ, &error);
  if (err < ER_OK) {
    goto err_ret1;
  }
  dd = err;

  err = b_rea_dev(dd, DN_KPINPUT, (B*)&kpinput, sizeof(kpinput), 
                  &asize, &error);
  if (err < ER_OK) {
    goto err_ret2;
  }
  inf->kpinput = kpinput;

  b_cls_dev(dd, 0, &error);
  dd = -1;

  /*
   * KB/PDɥ饤Фѿ
   */
  inf->evpd.stat.read   = 1;
  inf->evpd.stat.cmd    = INP_PD;
  inf->evpd.stat.rsv1   = 0;
  inf->evpd.stat.err    = DEV_OK;
  inf->evpd.stat.nodsp  = 0;
  inf->evpd.stat.rsv2   = 0;
  inf->evpd.stat.onebut = 0;
  inf->evpd.stat.abs    = 1;
  inf->evpd.stat.norel  = 0;
  inf->evpd.stat.tmout  = 0;
  inf->evpd.stat.butrev = 0;
  inf->evpd.stat.xyrev  = 0;
  inf->evpd.stat.rsv3   = 0;
  inf->evpd.stat.qpress = 0;
  inf->evpd.stat.inv    = 0;
  inf->evpd.stat.vst    = 0;
  inf->evpd.stat.sub    = 0;
  inf->evpd.stat.main   = 0;
  inf->evpd.xpos        = PDIN_XMAX / 2;
  inf->evpd.ypos        = PDIN_YMAX / 2;

  inf->evpd2.stat.read  = 1;
  inf->evpd2.stat.cmd   = INP_PD2;
  inf->evpd2.stat.rsv1  = 0;
  inf->evpd2.stat.err   = DEV_OK;
  inf->evpd2.stat.rsv2  = 0;
  inf->evpd2.wheel      = 0;
  inf->evpd2.rsv        = 0;

  inf->evkey.stat.read  = 1;
  inf->evkey.stat.cmd   = INP_KEY;
  inf->evkey.stat.rsv1  = 0;
  inf->evkey.stat.err   = DEV_OK;
  inf->evkey.stat.rsv2  = 0;
  inf->evkey.stat.kbid  = KID_IBM_JP;
  inf->evkey.stat.press = 0;
  inf->evkey.keytop     = 0;

  /* ǥХ׵դѥǥ֥ݡȤ */
  cpor.exinf   = 0;
  cpor.poratr  = TA_NULL;
  cpor.maxcmsz = sizeof(DevReq);
  cpor.maxrmsz = sizeof(DevRsp);
  err = vcre_por(&cpor);
  if (err < E_OK) {
    err = toERR(EC_INNER, err);
    goto err_ret2;
  }
  inf->acceptPort = (ID)err;

  /* ü׵դ */
  ctsk.exinf   = inf;
  ctsk.task    = synergySpecificRequestTask;
  ctsk.itskpri = inf->mypri;
  ctsk.stksz   = 2048;
  ctsk.tskatr  = TA_HLNG|TA_RNG0;

  err = vcre_tsk(&ctsk);
  if (err < E_OK) {
    err = toERR(EC_INNER, err);
    goto err_ret3;
  }
  tskid = (ID)err;

  err = sta_tsk(tskid, (INT)inf);
  if (err < E_OK) {
    err = toERR(EC_INNER, err);
    goto err_ret4;
  }

  /* ǥХϿ */
  err = registDevice(inf, True);
  if (err < ER_OK) {
    goto err_ret5;
  }

  /* ǥХ׵դ */
  err = synergyAcceptDeviceRequest(inf, D_NORM_PTN);
  if (err < ER_OK ) {
    goto err_ret6;
  }

  /*
   * ǥХɥ饤С̾ｪλʤΤǡ
   * 뤳ȤϤʤϤ
   */

  /* λ */
err_ret6:
  registDevice(inf, False);
err_ret5:
  ter_tsk(tskid);
err_ret4:
  del_tsk(tskid);
err_ret3:
  del_por(inf->acceptPort);
err_ret2:
  if (dd >= 0) {
    b_cls_dev(dd, 0, &error);
  }
err_ret1:
  DeleteLock(&inf->lock);
err_ret0:
  Kfree(inf);
  DEBUG_PRINT(("synergyMainTask err = %d\n", err));
  exd_tsk();
}


/* ------------------------------------------------------------------------ */

/*
 *  RS ɥ饤СΤư
 */
static WERR startSynergyDriver(PRI pri)
{
  SynergyDriverInfo *inf;
  T_CTSK ctsk;
  ID tskid;
  ERR err;

  /* ɥ饤Сν */
  inf = (SynergyDriverInfo*)Kcalloc(1, sizeof(SynergyDriverInfo));
  if (inf == NULL) {
    err = ER_NOMEM;
    goto err_ret0;
  }

  inf->mypri  = pri;

  /* ư */
  ctsk.exinf   = inf;
  ctsk.task    = synergyMainTask;
  ctsk.itskpri = pri;
  ctsk.stksz   = 2048;
  ctsk.tskatr  = TA_HLNG|TA_RNG0;
  err = vcre_tsk(&ctsk);
  if (err < E_OK) {
    err = toERR(EC_INNER, err);
    goto err_ret1;
  }
  tskid = (ID)err;

  err = sta_tsk(tskid, (INT)inf);
  if (err < E_OK) {
    err = toERR(EC_INNER, err);
    goto err_ret2;
  }

  return tskid;

err_ret2:
  del_tsk(tskid);
err_ret1:
  Kfree(inf);
err_ret0:
  DEBUG_PRINT(("startSynergyDriver err = %d\n", err));
  return err;
}


/*
 * ѥ᡼Ф
 */
static ERR getParameter(TC *arg)
{
  while (*arg != TNULL) {
    if (tc_isspace(*arg)) {
      arg++;
      continue;
    }

    switch (*arg++) {
    case L'':
      taskPri = tc_strtol(arg, &arg, 0);
      break;
    default:
      return ER_PAR;
    }
  }

  return ER_OK;
}


/*
 * Synergy ɥ饤
 */
ERR main(Bool StartUp, TC* arg)
{
  ERR	err;

  /* ɥ饤СϽλʤλ׵̵ */
  if (!StartUp) {
    return ER_NOSPT;
  }

  if (arg != NULL) {
    /* ѥ᡼Ф */
    err = getParameter(arg);
    if (err < ER_OK) {
      return err;
    }
  }

  startSynergyDriver(taskPri);
  return ER_OK;
}
