#ifndef DEFINE_H_SYNDRV
#define DEFINE_H_SYNDRV

#include <basic.h>
#include <itron/itron.h>
#include <itron/i386/idebug.h>
#include <itron/isyscall.h>
#include <util/debug.h>
#include <bsys/util.h>
#include <kernel/util.h>
#include <driver/driver.h>
#include <driver/kbpd.h>

#define DefaultPriority 80

#define DN_SYNERGY_PDMOVE    (-101) /* w */
#define DN_SYNERGY_PDRELMOVE (-102) /* w */
#define DN_SYNERGY_PDWHEEL   (-103) /* w */
#define DN_SYNERGY_PDINPUT   (-104) /* w */
#define DN_SYNERGY_PDLEAVE   (-105) /* w */
#define DN_SYNERGY_KEYINPUT  (-150) /* w */

typedef struct SynergyDriverPdMove_ {
  H    x;
  H    y;
  Bool enter;
} SynergyDriverPdMove;

typedef struct SynergyDriverPdRelMove_ {
  H    x;
  H    y;
} SynergyDriverPdRelMove;

typedef W SynergyDriverPdWheel;

typedef struct SynergyDriverPdInput_ {
  H    btn; // 1:left, 2:mid, 3:right
  H    rsv1;
  Bool on;
} SynergyDriverPdInput;

typedef W SynergyDriverPdLeave;

typedef struct SynergyDriverKeyInput_ {
  H    keytop;
  H    rsv1;
  Bool on;
} SynergyDriverKeyInput;


/*
 * 顼ɴϢ
 */
#define	EC_MASK			(0xffff0000)
#define	ED_MASK			(0x0000ffff)
#define	toERR(class,detail)	((ERR)((class) << 16 | (UH)(detail)))


/*
 * Synergy ɥ饤о
 */
typedef struct SynergyDriverInfo_ {
  PRI       mypri;
  ID        devID;
  ID        acceptPort;
  FastLock  lock;
  Bool      opened;
  Bool      suspended;
  DevReq*   devReq;
  ID        kpinput;
  PdInput   evpd;
  PdInput2  evpd2;
  KeyInput  evkey;
} SynergyDriverInfo;

#endif /* DEFINE_H_SYNDRV */
